import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Defines .
 * 
 * @author your name
 * @version 
 * 
 * FriendlyCat describes cats that 
 *  - walk and jump when corresponding control keys are pressed
 *  - look for pizza, eat it, and dance with joy after eating three slices in a row
 *  - should avoid mean animals if it wants to live a pizza-eating happy life
 *  - used in friendly-cat scenario
 */
public class FriendlyCat  extends Cat
{
    private int pizzasEaten; 
    private int poisonapplesEaten;
    public void act()
    {
     keyControlMove();
     if(foundPizza()) {
            eatPizza();
        }
     if(foundPoisonApple()) {
         eatPoisonApple();
        }
     lookForPizza();
     lookForPoisonApple();
    }
    public void lookForPizza()
    {
        if (canSee(Pizza.class))
        {
            eat();
            Greenfoot.playSound("slurp.wav");
            pizzasEaten = pizzasEaten + 1;
            if (pizzasEaten == 3)
            {
                dance();

            }
        }
    }
    public void lookForPoisonApple()
    {
        if (canSee(PoisonApple.class))
        {
            eat();
            Greenfoot.playSound("slurp.wav");
            poisonapplesEaten = poisonapplesEaten + 1;
            if (poisonapplesEaten == 3)
            {
                sleep(10);

            }
        }
    }
    public void keyControlMove()
    {
        if (Greenfoot.isKeyDown("up"))
        {
            jumpUp(1); 
        }
        if (Greenfoot.isKeyDown("left"))
        {
            walkLeft(1);      
        }
        if (Greenfoot.isKeyDown("right"))
        {
            walkRight(1);
        }
        if (Greenfoot.isKeyDown("down"))
        {
            jumpDown(1);
        }
    }
    public void FriendlyCat()
    {
        pizzasEaten = 0;
        poisonapplesEaten = 0;
    }
    public void eatPizza()
    {
        Actor pizza = getOneObjectAtOffset(0, 0, Pizza.class);  
        int x = Greenfoot.getRandomNumber(559);
        int y = Greenfoot.getRandomNumber(559);
        if(pizza != null) {
            // eat the pizza...
            getWorld().removeObject(pizza);
            pizzasEaten = pizzasEaten + 1;  
           getWorld().addObject(new Pizza(), x, y);
            if (pizzasEaten == 3)
            {
                dance(); 
                pizzasEaten = 0;
            }
        
        }
    }
    public void eatPoisonApple()
    {
        Actor poisonapple = getOneObjectAtOffset(0, 0, PoisonApple.class);  
        int x = Greenfoot.getRandomNumber(559);
        int y = Greenfoot.getRandomNumber(559);
        if(poisonapple != null) {
            // eat the poisonapple...
            getWorld().removeObject(poisonapple);
            poisonapplesEaten = poisonapplesEaten + 1;  
           getWorld().addObject(new PoisonApple(), x, y);
            if (poisonapplesEaten == 1)
            {
                sleep(10);
                poisonapplesEaten = 0;
            }
        
        }
    }
    public boolean foundPizza()
    {
        Actor pizza = getOneObjectAtOffset(0, 0, Pizza.class);
        if(pizza != null) {
            return true;
        }
        else {
            return false;
        }
    }
    public boolean foundPoisonApple()
    {
        Actor poisonapple = getOneObjectAtOffset(0, 0, PoisonApple.class);
        if(poisonapple != null) {
            return true;
        }
        else {
            return false;
        }
    }
}

